/***************************************************************/
//
//
//		DirectX	[ game_equation.h ]
//
//										Author	kazuki tanaka
//										Date	2016 06/19
/*---------------------------------------------------------------
Update : 2016/06/19
			config.h̍쐬

Update : 2016/07/10
			ht@C̒gV
			game_equation.h ɖ̂̕ύX

Update : 2016/07/10
			`Ƌ`̔̒ǉ
			~Ɖ~̔̒ǉ

Update : 2016/07/20
			Ƌ̓蔻̒ǉ
			( 3Dp )

Update : 2016/08/11
			IuWFNg̉ʊO
			肷鏈ǉ
			( 2Dp );

/*---------------------------------------------------------------
	CN[ht@C
---------------------------------------------------------------*/
#ifndef _GAME_EQUATION_H_

#define _GAME_EQUATION_H_

#include "main.h"
#include <stdlib.h>

/*---------------------------------------------------------------
	}N`
---------------------------------------------------------------*/


#define ONEHUNDRED_EIGTEEN ( 0.0055555555f )		// 1/180̌vZl

#define RADIAN(arc) (((arc) * D3DX_PI ) / 180)		// WǍvZɕKv

#define LIMIT_MAX(a,b) ( a>b ? b : a )				// ől̐ݒ( ႢlԂ )
#define LIMIT_MIM(a,b) ( a>b ? a : b )				// ŏl̐ݒ( lԂ )

// AtBϊ
#define AFFINE_TRANSFORM_X( radiusX, radiusY, theta ) \
(( radiusX ) * cosf( RADIAN( theta )) - ( radiusY ) * sinf( RADIAN( theta )))

#define AFFINE_TRANSFORM_Y( radiusX, radiusY, theta ) \
(( radiusX ) * sinf( RADIAN( theta )) + ( radiusY ) * cosf( RADIAN( theta )))



/*---------------------------------------------------------------
	Tu[`( CC֐ )
---------------------------------------------------------------*/

// `Ƌ`̂蔻
inline bool __CollisionObjectSquare( const LPD3DXVECTOR2 objectA_s ,const LPD3DXVECTOR2 objectA_e, const LPD3DXVECTOR2 objectB_s, const LPD3DXVECTOR2 objectB_e )
{

	// 
	if( ( objectA_s->x < objectB_e->x ) && ( objectA_e->x < objectB_s->x ) && ( objectA_s->y < objectB_e->y ) && ( objectA_e->y < objectB_s->y ) ){
		
		// contact 
		return true;

	}

	// not contact
	return false;

	
	/*
	//
	for( int inc=vec.prevX ; inc < vec.sx ;inc++ ){
		if( objVec.sx < vec.prevX && vec.prevX < objVec.ex ){
			vec.sx = objVec.sx+1;
			vec.ex = objVec.ex+1;
			break;
		}
	}

	//
	for( int inc=vec.prevX ; inc < vec.ex ;inc++ ){
		if( objVec.sx < vec.prevX && vec.prevX < objVec.ex ){
			vec.sx = objVec.sx-1;
			vec.ex = objVec.ex-1;
			break;
		}
	}

	//
	for( int inc=vec.prevY ; inc < vec.sy ;inc++ ){
		if( objVec.sy < vec.prevX && vec.prevY < objVec.ey ){
			vec.sy = objVec.sy-1;
			vec.ey = objVec.ey-1;
			break;
		}
	}

	//
	for( int inc=vec.prevY ; inc < vec.ey ;inc++ ){
		if( objVec.sy < vec.prevX && vec.prevY < objVec.ey ){
			vec.sy = objVec.sy-1;
			vec.ey = objVec.ey-1;
			break;
		}
	}
	*/
	

}

// CollisionDetection

// ~Ɖ~̂蔻
inline bool __CollisionObjectCircle( const LPD3DXVECTOR2 object_centerA, const LPD3DXVECTOR2 object_centerB,const LPD3DXVECTOR2 object_radiusA, const LPD3DXVECTOR2 object_radiusB )
{


	D3DXVECTOR2 difference;					//XY̍
	float       distance;					//



	// IuWFNgA,BX,Y̍̌vZ
	difference.x = ( object_centerA->x - object_centerB->x ) * ( object_centerA->x - object_centerB->x );	//x2
	difference.y = ( object_centerA->y - object_centerB->y ) * ( object_centerA->y - object_centerB->y );	//y2


	// IuWFNgAƃIuWFNgB̋
	distance = ( ( difference.x ) + ( difference.y ) );			// r̂Q : r2 = x2 + y2 ;

	// 
	if( distance < ( object_radiusA->x + object_radiusB->x ) * ( object_radiusA->x + object_radiusB->x ) ){
	
		return true;	//ڂĂ
	
	}

	return false;	//ڂĂȂ

}

// Ƌ̂蔻
inline bool __CollisionObjectSphere( const LPD3DXVECTOR3 object_centerA, const LPD3DXVECTOR3 object_centerB,const float radiusA, const float radiusB )
{

	D3DXVECTOR3 difference;					//XY̍
	float       distance;					//


	// IuWFNgA,BX,Y̍̌vZ
	difference.x = ( object_centerA->x - object_centerB->x ) * ( object_centerA->x - object_centerB->x );	//x2
	difference.y = ( object_centerA->y - object_centerB->y ) * ( object_centerA->y - object_centerB->y );	//y2
	difference.y = ( object_centerA->z - object_centerB->z ) * ( object_centerA->z - object_centerB->z );	//z2

	// IuWFNgAƃIuWFNgB̋
	distance = ( ( difference.x ) + ( difference.y ) + ( difference.z ) );			// r̂Q : r2 = x2 + y2 + z2 ;

	// 
	if( distance < ( radiusA + radiusB ) * ( radiusA + radiusB ) ){
	
		return true;	//ڂĂ
	
	}
	return false;	//ڂĂȂ

}

// ʊO𔻒( 2DQ[p )
inline bool __ObjectScreenOut(  const LPD3DXVECTOR2 object_center, const LPD3DXVECTOR2 radius )
{

	// ʊOvZ
	if( !( object_center->y + radius->y > 0 &&
		object_center->x + radius->x > 0 &&
		object_center->y - radius->y < SCREEN_HEIGHT &&
		object_center->x - radius->x < SCREEN_WIDTH ) ){

		// ʊO
		return true;

	}


	// ʓ
	return false;

}

inline bool __ObjectScreenOut(  const LPD3DXVECTOR2 object_center, const float radius )
{

	// ʊOvZ
	if( !( object_center->y + radius > 0 &&
		object_center->x + radius > 0 &&
		object_center->y - radius < SCREEN_HEIGHT &&
		object_center->x - radius < SCREEN_WIDTH ) ){

		// ʊO
		return true;

	}


	// ʓ
	return false;

}

// ʊO𔻒( 2DQ[p ) -> Vvɉ( vC[Ƃ͂... )
inline bool __ObjectScreenOutSimple( const LPD3DXVECTOR2 object_center )
{

	// ʊOvZ
	if( !( object_center->y > 0 &&
		object_center->x > 0 &&
		object_center->y < SCREEN_HEIGHT &&
		object_center->x < SCREEN_WIDTH ) ){

		// ʊO
		return true;

	}


	// ʓ
	return false;

}

// _Ɖ~̂蔻( 2Dp )
inline bool __ObjectTouchSphere( const LPD3DXVECTOR2 objectCenter, const float objectRadius, const LPD3DXVECTOR2 pos )
{

	float       distance;					//

	distance = ( objectCenter->x - pos->x ) * ( objectCenter->x - pos->x ) + ( objectCenter->y - pos->y ) * ( objectCenter->y - pos->y );


	// 蔻
	if( distance < objectRadius * objectRadius ){
	
		// Ă
		return true;
	
	}

	// ĂȂ
	return false;

}

// _Ƌ`̂蔻( 2Dp )
inline bool __ObjectTouchSquare( const LPD3DXVECTOR2 object_start, const LPD3DXVECTOR2 object_end, const LPD3DXVECTOR2 point )
{

	// 蔻
	if( object_start->x < point->x && object_start->y < point->y 
		&& object_end->x > point->x && object_end->y > point ->y ){
	
		// Ă
		return true;
	
	}

	// ĂȂ
	return false;


}


#endif	//_GAME_EQUATION_H_



