/***************************************************************/
//
//
//		DirectX	[tool_proc.cpp]
//
//										Author	kazuki tanaka
//										Date	2016 11/30
/*---------------------------------------------------------------
Update : 2016/11/30
			tool_proc.cpp̍쐬
			func : InitParticle̒ǉ
			func : UninitParticle̒ǉ
			func : UpdateParticle̒ǉ
			func : DrawParticle̒ǉ
			func : MakeVertexParticle̒ǉ
			func : SetVertexParticleCoord̒ǉ
			func : SetVertexParticleColor̒ǉ
			func : SetVertexParticleSpriteUV̒ǉ
			func : SetVertexParticleNormal̒ǉ
			func : SetParticle̒ǉ

			Update : UpdateParticle 
						-> Z\[g̒ǉ

Update : 2016/11/30


/*---------------------------------------------------------------
	wb_[t@C
---------------------------------------------------------------*/

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "resource.h"
#include "main.h"
#include "tool_proc.h"

#include "emitter.h"
#include "controller.h"
#include "polygon.h"

#include "particle.h"

/*----------------------------------------------------------------
	O[oϐ
----------------------------------------------------------------*/

static EMITTER* emitter = nullptr;
static int index = 0;

static HWND dlgWnd;
bool UpdateEdit = true;


// _CAOvV[W
BOOL CALLBACK EditEmitterDlgProc( HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam )
{
    switch( Msg ){

    case WM_INITDIALOG:{

		// _CAOnh̎擾
		dlgWnd = hDlg;

		// EMITTERAhX̎擾
		emitter = GetEmitter( );
		index   = GetEmitterIndex( );
		}return TRUE;

	case WM_COMMAND:
		
		if( (!UpdateEdit) && LOWORD( wParam )){
			 SetEmitterEditStatus( );
		}break;

    switch(LOWORD(wParam)){
    case IDOK:
			break;
	case IDCANCEL:
            EndDialog(hDlg, 0);
            return TRUE;}
    case WM_CLOSE:
        EndDialog(hDlg, 0);
        return TRUE;
    }
    return FALSE;
}

// GfBbg̕ҏW
void SetEditText( const HWND dialogWnd ,const int EDIT_ID, float parameter )
{

	char str[256] = { };
	sprintf( str, "%f", parameter );
    SetDlgItemText( dialogWnd, EDIT_ID, str );

}

// GfBbg̕ҏW
void SetEditText( const int EDIT_ID, float parameter )
{

	char str[256] = { };
	sprintf( str, "%f", parameter );
    SetDlgItemText( dlgWnd, EDIT_ID, str );

}

// GfBbg̍XV
void UpdateDlgEdit( void )
{

	if( !UpdateEdit ){
		return;
	}

	// EMITTERAhX̎擾
	emitter = GetEmitter( );
	index   = GetEmitterIndex( );

	// EMITTER EDITւ̏
	SetEditText( dlgWnd, IDC_EDIT1, emitter[ index ].center.x );
	SetEditText( dlgWnd, IDC_EDIT2, emitter[ index ].center.y );
	SetEditText( dlgWnd, IDC_EDIT3, emitter[ index ].center.z );
	SetEditText( dlgWnd, IDC_EDIT4, emitter[ index ].speed.x );
	SetEditText( dlgWnd, IDC_EDIT5, emitter[ index ].speed.y );
	SetEditText( dlgWnd, IDC_EDIT6, emitter[ index ].speed.z );
	SetEditText( dlgWnd, IDC_EDIT7, emitter[ index ].velocity.x );
	SetEditText( dlgWnd, IDC_EDIT8, emitter[ index ].velocity.y );
	SetEditText( dlgWnd, IDC_EDIT9, emitter[ index ].velocity.z );
	SetEditText( dlgWnd, IDC_EDIT10, emitter[ index ].color.r );
	SetEditText( dlgWnd, IDC_EDIT11, emitter[ index ].color.g );
	SetEditText( dlgWnd, IDC_EDIT12, emitter[ index ].color.b );
	SetEditText( dlgWnd, IDC_EDIT13, emitter[ index ].color.a );
	SetEditText( dlgWnd, IDC_EDIT14, emitter[ index ].radius );
	SetEditText( dlgWnd, IDC_EDIT15, emitter[ index ].theta );
	SetEditText( dlgWnd, IDC_EDIT16, emitter[ index ].theta_offset );
	SetEditText( dlgWnd, IDC_EDIT17, emitter[ index ].phy );
	SetEditText( dlgWnd, IDC_EDIT18, emitter[ index ].phy_offset );
	SetEditText( dlgWnd, IDC_EDIT19, emitter[ index ].life );
	SetEditText( dlgWnd, IDC_EDIT20, index );
	SetEditText( dlgWnd, IDC_EDIT21, emitter[ index ].textureIndex );
	UpdateEdit = false;

}

// GfBbg̒l擾
void SetEmitterEditStatus( void )
{

	char str[256] = { };
	
	// EDITINDEX̎擾 
	index   = GetEmitterIndex( );

	GetDlgItemText(dlgWnd, IDC_EDIT1, str, 255);
	emitter[index].center.x = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT2, str, 255);
	emitter[index].center.y = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT3, str, 255);
	emitter[index].center.z = atof( str );

	GetDlgItemText(dlgWnd, IDC_EDIT4, str, 255);
	emitter[index].speed.x = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT5, str, 255);
	emitter[index].speed.y = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT6, str, 255);
	emitter[index].speed.z = atof( str );

	GetDlgItemText(dlgWnd, IDC_EDIT7, str, 255);
	emitter[index].velocity.x = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT8, str, 255);
	emitter[index].velocity.y = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT9, str, 255);
	emitter[index].velocity.z = atof( str );

	GetDlgItemText(dlgWnd, IDC_EDIT10, str, 255);
	emitter[index].color.r = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT11, str, 255);
	emitter[index].color.g = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT12, str, 255);
	emitter[index].color.b = atof( str );
	GetDlgItemText(dlgWnd, IDC_EDIT13, str, 255);
	emitter[index].color.a = atof( str );

	GetDlgItemText(dlgWnd, IDC_EDIT14, str, 255);
	emitter[index].radius = atof( str );

	GetDlgItemText(dlgWnd, IDC_EDIT15, str, 255);
	if( atoi( str ) ){
		emitter[index].theta = atoi( str );
	}else{
		emitter[index].theta = 1;			
	}
	GetDlgItemText(dlgWnd, IDC_EDIT16, str, 255);
	emitter[index].theta_offset = atoi( str );

	GetDlgItemText(dlgWnd, IDC_EDIT17, str, 255);
	if( atoi( str ) ){
		emitter[index].phy = atoi( str );
	}else{
		emitter[index].phy = 1;			
	}
	GetDlgItemText(dlgWnd, IDC_EDIT18, str, 255);
	emitter[index].phy_offset = atoi( str );

	GetDlgItemText(dlgWnd, IDC_EDIT19, str, 255);
	emitter[index].life = atoi( str );

	GetDlgItemText(dlgWnd, IDC_EDIT20, str, 255);
	SetEmitterIndex( atoi( str ) );

	GetDlgItemText(dlgWnd, IDC_EDIT21, str, 255);
	int whiteBox = atoi( str );
	if( whiteBox > PARTICLE::LOAD_TEXTURE-1 ){
		whiteBox = PARTICLE::LOAD_TEXTURE-1;
		//whiteBox --;
	}
	else if( whiteBox < 0 ){
		whiteBox = 0;
	}
	emitter[index].textureIndex = whiteBox;
	//SetTextureIndexEmitter( atoi( str ) );

}

// Abvf[gtO
void EmitterUpdateFrag( const bool frag )
{

	UpdateEdit = frag;

}




